'''
spamassassin module, version 0.2

(c) 2003 Jan ONDREJ (SAL) <ondrejj@salstar.sk>
                                                                                
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

'''

from avlib import *
import re,socket

def process(pf,spamstring):
    ret=[]
    exitstatus=''
    for line in pf.readlines():
      if re.search("^X-Spam-",line):
        ret.append(line)
        if re.search(spamstring,line):
          exitstatus='SPAM'
    return exitstatus,ret

def spamassassin(stream,scanner,spamstring='^X-Spam-Flag: YES',maxfilesize=500000):
    if len(stream)>maxfilesize:
      return '',[]
    pf=popen(scanner)
    pf.write(stream)
    pf.close(1)
    return process(pf,spamstring)

def spamd(stream,scanner,spamstring='^X-Spam-Flag: YES',maxfilesize=500000):
    if len(stream)>maxfilesize:
      return '',[]
    s=socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    s.connect((scanner[0],scanner[1]))
    f=s.makefile('rw',4096)
    s.send("PROCESS SPAMC/1.2\r\n")
    s.send("Content-length: "+str(len(stream))+"\r\n")
    s.send("User: test\r\n\r\n")
    s.send(stream)
    s.shutdown(1)
    return process(f,spamstring)
